//*****************************************************************************************************
//  1. t@C
//		SchematicView.cpp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		ڑn}E@\n}E@\}Flash\pr[
//----------------------------------------------------------------------------------------------------
//  3. l
//*****************************************************************************************************

#include "stdafx.h"
#include "Schematic.h"
#include "SchematicFrm.h"
#include "SchematicView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CSchematicView

IMPLEMENT_DYNCREATE(CSchematicView, CWnd)

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::CSchematicView
//----------------------------------------------------------------------------------------------------
//  2. @\
//		RXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
CSchematicView::CSchematicView()
{
	// oϐ
	m_fZoomRatio = 1;
	m_bInScroll = FALSE;
	m_bScroll = FALSE;
	m_pMenuDlg = NULL;
	m_bQuickMode = FALSE;
	m_hCursorHandClose = AfxGetApp()->LoadCursor(IDC_HANDCLOSE);
}


BEGIN_MESSAGE_MAP(CSchematicView, CWnd)
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	ON_WM_CREATE()
	ON_MESSAGE(WM_USER_ZOOM_IN, OnUserZoomIn)
	ON_MESSAGE(WM_USER_ZOOM_OUT, OnUserZoomOut)
	ON_MESSAGE(WM_USER_SIZE_RESET, OnUserSizeReset)
	ON_MESSAGE(WM_USER_PRINT, OnUserPrint)
	ON_MESSAGE(WM_USER_EXIT, OnUserExit)
	ON_MESSAGE(WM_USER_ACTION, OnUserAction)
	ON_MESSAGE(WM_USER_PAUSE, OnUserPause)
	ON_MESSAGE(WM_USER_SLOW, OnUserSlow)
	ON_MESSAGE(WM_USER_NORMAL, OnUserNormal)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
#ifdef _DEVELOP
	ON_WM_RBUTTONUP()
	ON_COMMAND(IDM_QUICK_MODE, &CSchematicView::OnQuickMode)
	ON_COMMAND(IDM_SCREEN_COPY, &CSchematicView::OnScreenCopy)
	ON_COMMAND(IDM_START_ALL, &CSchematicView::OnStartAll)
#endif
END_MESSAGE_MAP()



// CSchematicView bZ[W nh

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::PreCreateWindow
//----------------------------------------------------------------------------------------------------
//  2. @\
//		RXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CREATESTRUCT&		cs			[I] EBhEp[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	TRUE
//*****************************************************************************************************
BOOL CSchematicView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(/*CS_HREDRAW|CS_VREDRAW|*/CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), reinterpret_cast<HBRUSH>(COLOR_WINDOW+1), NULL);

	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::OnCreate
//----------------------------------------------------------------------------------------------------
//  2. @\
//		t[EBhE쐬
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCREATESTRUCT		lpCreateStruct			[I] EBhEp[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		int		0
//*****************************************************************************************************
int CSchematicView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	// t[EBhẼ|C^ۑ
	m_pSchematicFrm = (CSchematicFrame *)GetParent();

	return 0;
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::OnPaint
//----------------------------------------------------------------------------------------------------
//  2. @\
//		yCg(WM_PAINT)bZ[Wnh
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CSchematicView::OnPaint() 
{
	// \FlashŝŁAr[͕̂`͍sȂ
	CPaintDC dc(this);
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::ShowSchematic
//----------------------------------------------------------------------------------------------------
//  2. @\
//		}\EBhE\
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CRuntimeClass	*pMenuClass			[I] 상j[NX
//		CString			&sFlashFileName		[I] Flash̃t@C
//		int				nActionCode			[I] ANVR[h
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CSchematicView::ShowSchematic(CRuntimeClass *pMenuClass, const CString &sFlashFileName, int nActionCode)
{
	// FlashEBhȆ傫
	InitFlashRect();

	// FlashEBhE쐬
	if (m_cFlash.m_hWnd != NULL)
		m_cFlash.DestroyWindow();
	m_cFlash.Create(NULL, NULL, WS_CHILD, m_rectFlash, this, 0);

	// FlashEBhEXN[
	ScrollFlashWindow();

	// swft@C\
	CString sFullPath;
	_fullpath(sFullPath.GetBuffer(MAX_PATH), CSchematic::m_sFlashDir + "\\" + sFlashFileName, MAX_PATH);
	sFullPath.ReleaseBuffer();
	sFullPath += "?";
	m_cFlash.LoadMovie(0, sFullPath);

	// Xe[W̃TCY擾
	try {
		m_sizeStage.cx = atoi(m_cFlash.GetVariable("stageWidth"));
		m_sizeStage.cy = atoi(m_cFlash.GetVariable("stageHeight"));
	} catch (CException *e) {
		e->Delete();
	}

	if (nActionCode != 0)
		FlashAction(nActionCode, NULL);
	m_cFlash.ShowWindow(SW_SHOW);

	// 상j[\
	if (m_pMenuDlg != NULL)
		m_pMenuDlg->DestroyWindow();
	if (pMenuClass != NULL) {
		m_pMenuDlg = (CMenuCommon *)pMenuClass->CreateObject();
		if (m_pMenuDlg != NULL) {
			m_pMenuDlg->DoModeless(this);

			CString sTitle;
			GetParent()->GetWindowText(sTitle);
			m_pMenuDlg->SetWindowText(sTitle + "j[");
		}
	}
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::OnSize
//----------------------------------------------------------------------------------------------------
//  2. @\
//		EBhETCYύXbZ[W(WM_SIZE)nh
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT	nType		[I] TCYύX̃^Cv
//		int		cx			[I] NCAg̈̕
//		int		cy			[I] NCAg̈̍
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CSchematicView::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);

	// ݂̃r[TCYۑ
	m_sizeView.SetSize(cx, cy);

	// FlashEBhẼXN[
	if (m_cFlash.m_hWnd != NULL)
		ScrollFlashWindow();
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::OnHScroll
//----------------------------------------------------------------------------------------------------
//  2. @\
//		XN[bZ[W(WM_HSCROLL)nh
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT		nSBCode			[I] XN[vR[h
//		UINT		nPos			[I] XN[{bNẌʒu
//		CScrollBar*	pScrollBar		[I] XN[o[Rg[
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CSchematicView::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	// FlashEBhE̍WXV
	m_rectFlash.MoveToX(-GetNextScrollPos(SB_HORZ, nSBCode, nPos));

	// FlashEBhẼXN[
	ScrollFlashWindow();

	CWnd::OnHScroll(nSBCode, nPos, pScrollBar);
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::OnVScroll
//----------------------------------------------------------------------------------------------------
//  2. @\
//		XN[bZ[W(WM_VSCROLL)nh
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT		nSBCode			[I] XN[vR[h
//		UINT		nPos			[I] XN[{bNẌʒu
//		CScrollBar*	pScrollBar		[I] XN[o[Rg[
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CSchematicView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	// FlashEBhE̍WXV
	m_rectFlash.MoveToY(-GetNextScrollPos(SB_VERT, nSBCode, nPos));

	// FlashEBhẼXN[
	ScrollFlashWindow();

	CWnd::OnVScroll(nSBCode, nPos, pScrollBar);
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::OnLButtonDown
//----------------------------------------------------------------------------------------------------
//  2. @\
//		}EX{^_EbZ[W(WM_LBUTTONDOWN)nh
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT	nFlags			[I] Ă鉼zL[
//		CPoint	point			[I] }EXJ[\̍W
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CSchematicView::OnLButtonDown(UINT nFlags, CPoint point)
{
	if (GetStyle() & (WS_HSCROLL | WS_VSCROLL)) {
		// }EX|C^ʒuۑ
		m_pointScroll = point;

		// }EXLv`
		SetCapture();
	}

	CWnd::OnLButtonDown(nFlags, point);
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::OnLButtonUp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		}EX{^AbvbZ[W(WM_LBUTTONUP)nh
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT	nFlags			[I] Ă鉼zL[
//		CPoint	point			[I] }EXJ[\̍W
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CSchematicView::OnLButtonUp(UINT nFlags, CPoint point)
{
	// }EXJ[\ɖ߂ăXN[I
	if (GetCapture()->GetSafeHwnd() == m_hWnd) {
		::SetCursor(m_hCursorHandClose);
		m_bScroll = FALSE;
		ReleaseCapture();
	}

	CWnd::OnLButtonUp(nFlags, point);
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::OnMouseMove
//----------------------------------------------------------------------------------------------------
//  2. @\
//		}EXړbZ[W(WM_MOUSEMOVE)nh
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT	nFlags			[I] Ă鉼zL[
//		CPoint	point			[I] }EXJ[\̍W
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CSchematicView::OnMouseMove(UINT nFlags, CPoint point)
{
	if (m_bScroll) {
		// XN[Ȃ}EẌʒuɍ킹ăEBhEXN[
		m_rectFlash.MoveToX(-GetNextScrollPos(SB_HORZ, SB_THUMBTRACK, m_pointScroll.x - point.x - m_rectFlash.left));
		m_rectFlash.MoveToY(-GetNextScrollPos(SB_VERT, SB_THUMBTRACK, m_pointScroll.y - point.y - m_rectFlash.top));
		ScrollFlashWindow();
		m_cFlash.UpdateWindow();
		m_pointScroll = point;
	} else {
		// }EX{^Ă΃}EXJ[\ύXAXN[tOON
		if (GetCapture()->GetSafeHwnd() == m_hWnd) {
			m_bScroll = TRUE;
			m_hCursorSave = ::SetCursor(m_hCursorHandClose);
		}
	}

	CWnd::OnMouseMove(nFlags, point);
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::PreTranslateMessage
//----------------------------------------------------------------------------------------------------
//  2. @\
//		EBhEbZ[W̃tB^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		MSG*	pMsg			[I] bZ[Wf[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	CWnd::PreTranslateMessage(pMsg)
//*****************************************************************************************************
BOOL CSchematicView::PreTranslateMessage(MSG* pMsg)
{
	switch (pMsg->message) {
	case WM_LBUTTONDOWN:
	case WM_LBUTTONUP:
	case WM_RBUTTONDOWN:
	case WM_RBUTTONUP:
	case WM_MOUSEMOVE:
		// FlashEBhẺ̃r[EBhEɃ}EXbZ[W]
		{
			char sClassName[256];
			GetClassName(pMsg->hwnd, sClassName, sizeof(sClassName));
			if (strcmp(sClassName, "MacromediaFlashPlayerActiveX") == 0) {
				if (pMsg->message == WM_RBUTTONDOWN)
					return TRUE;
				CPoint point((int)(pMsg->lParam & 0xFFFF), (int)((pMsg->lParam >> 16) & 0xFFFF));
				HWND hParent = ::GetParent(pMsg->hwnd);
				if (hParent != NULL) {
					::MapWindowPoints(pMsg->hwnd, hParent, &point, 1);
					::SendMessage(hParent, pMsg->message, pMsg->wParam, point.x | (point.y << 16));
				}
			}
		}
		break;
	}

	return CWnd::PreTranslateMessage(pMsg);
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::OnUserZoomIn
//----------------------------------------------------------------------------------------------------
//  2. @\
//		상j[́ugv{^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		WPARAM	wParam			[I] bZ[Wp[^
//		LPARAM	lParam			[I] bZ[Wp[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		LRESULT		g債ĂFlash̃TCY4096ȓȂTRUEAꍇFALSEi4096x̂߁j
//*****************************************************************************************************
LRESULT CSchematicView::OnUserZoomIn(WPARAM wParam, LPARAM lParam)
{
	// 1.25{Ɋg傷
	SetZoomRatio(m_fZoomRatio * 1.25);

	// ēxg\`FbN
	double fScaleX = m_rectFlash.Width() / (double)m_sizeStage.cx;
	double fScaleY = m_rectFlash.Height() / (double)m_sizeStage.cy;
	double fScale = min(fScaleX, fScaleY);
	int nRight = (m_rectFlash.Width() + (int)(m_sizeStage.cx * fScale)) / 2;
	int nBottom = (m_rectFlash.Height() + (int)(m_sizeStage.cy * fScale)) / 2;
	return max(nRight, nBottom) * 1.25 <= 4096;
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::OnUserZoomOut
//----------------------------------------------------------------------------------------------------
//  2. @\
//		상j[́ukv{^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		WPARAM	wParam			[I] bZ[Wp[^
//		LPARAM	lParam			[I] bZ[Wp[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		LRESULT		g嗦0.25ȏȂTRUEAȊOFALSE
//*****************************************************************************************************
LRESULT CSchematicView::OnUserZoomOut(WPARAM wParam, LPARAM lParam)
{
	// 1/1.25ɏk
	SetZoomRatio(m_fZoomRatio / 1.25);

	return m_fZoomRatio >= 0.25;
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::OnUserSizeReset
//----------------------------------------------------------------------------------------------------
//  2. @\
//		상j[́uTCYZbgv{^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		WPARAM	wParam			[I] bZ[Wp[^
//		LPARAM	lParam			[I] bZ[Wp[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		LRESULT	0
//*****************************************************************************************************
LRESULT CSchematicView::OnUserSizeReset(WPARAM wParam, LPARAM lParam)
{
	// XN[o[
	m_bInScroll = TRUE;
	ShowScrollBar(SB_BOTH, FALSE);
	m_bInScroll = FALSE;

	// FlashEBhEXN[
	InitFlashRect();
	ScrollFlashWindow();

	return 0;
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::OnUserPrint
//----------------------------------------------------------------------------------------------------
//  2. @\
//		상j[́uv{^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		WPARAM	wParam			[I] bZ[Wp[^
//		LPARAM	lParam			[I] bZ[Wp[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		LRESULT	0
//*****************************************************************************************************
LRESULT CSchematicView::OnUserPrint(WPARAM wParam, LPARAM lParam)
{
	CRect rectView(0, 0, m_sizeView.cx, m_sizeView.cy);
	double fStageWidth = m_sizeStage.cx;
	double fStageHeight = m_sizeStage.cy;
	double fRatio = min(m_rectFlash.Width() / fStageWidth, m_rectFlash.Height() / fStageHeight);
	CPoint pointCenter = m_rectFlash.CenterPoint();
	CPoint pointLeftTop(pointCenter.x - (int)(fStageWidth / 2 * fRatio), pointCenter.y - (int)(fStageHeight / 2 * fRatio));
	rectView.MoveToXY(-pointLeftTop);

	CString sTitle;
	GetParent()->GetWindowText(sTitle);

	CString sParam;
	sParam.Format("<arguments><number>%d</number><number>%d</number><number>%d</number><number>%d</number><string>%s</string></arguments>",
		(int)(rectView.left / fRatio),
		(int)(rectView.top / fRatio),
		(int)(rectView.right / fRatio),
		(int)(rectView.bottom / fRatio),
		sTitle);
	CallFlashFunction("extPrint", sParam);
/*
	CPrintDialog dlg(FALSE);

	// pɐݒ
	dlg.GetDefaults();
	LPDEVMODE lpDevInfo = dlg.GetDevMode();
	lpDevInfo->dmOrientation = DMORIENT_LANDSCAPE;
    dlg.m_pd.Flags &= ~PD_RETURNDEFAULT;

	if(dlg.DoModal() == IDOK) {
		// pCDC擾
		CDC	dc;
		dc.Attach(dlg.GetPrinterDC());

		int nWidth = dc.GetDeviceCaps(HORZRES);
		int nHeight = dc.GetDeviceCaps(VERTRES);

		CDC dcMem;
		CBitmap bmpMem;
		dcMem.CreateCompatibleDC(&dc);
		bmpMem.CreateCompatibleBitmap(&dc, nWidth, nHeight);
		dcMem.SelectObject(&bmpMem);

		// DOCINFOp
		DOCINFO	docinfo;
		memset(&docinfo, 0, sizeof(docinfo));
		docinfo.cbSize  = sizeof(docinfo);
		docinfo.lpszDocName = "Test";

		// Jn
		dc.StartDoc(&docinfo);

		// y[WJn
		dc.StartPage();
		m_cFlash.PrintWindow(&dcMem, 0);
		dc.StretchBlt(0, 0, nWidth, nHeight, &dcMem, 0, 0, m_rectFlash.Width(), m_rectFlash.Height(), SRCCOPY);

		// y[WI
		dc.EndPage();

		// I
		dc.EndDoc();
	}
*/
	return 0;
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::OnUserExit
//----------------------------------------------------------------------------------------------------
//  2. @\
//		상j[́uIv{^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		WPARAM	wParam			[I] bZ[Wp[^
//		LPARAM	lParam			[I] bZ[Wp[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		LRESULT	0
//*****************************************************************************************************
LRESULT CSchematicView::OnUserExit(WPARAM wParam, LPARAM lParam)
{
	// eEBhEit[EBhEj
	GetParent()->SendMessage(WM_CLOSE);

	return 0;
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::OnUserAction
//----------------------------------------------------------------------------------------------------
//  2. @\
//		상j[̊e{^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		WPARAM	wParam			[I] bZ[Wp[^
//		LPARAM	lParam			[I] bZ[Wp[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		LRESULT	0
//*****************************************************************************************************
LRESULT CSchematicView::OnUserAction(WPARAM wParam, LPARAM lParam)
{
	// FlashɓwR}h𑗐M
	FlashAction((int)wParam, (CUIntArray *)lParam);

	return 0;
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::OnUserPause
//----------------------------------------------------------------------------------------------------
//  2. @\
//		상j[̈ꎞ~{^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		WPARAM	wParam			[I] bZ[Wp[^
//		LPARAM	lParam			[I] bZ[Wp[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		LRESULT	0
//*****************************************************************************************************
LRESULT CSchematicView::OnUserPause(WPARAM wParam, LPARAM lParam)
{
	// FlashɓwR}h𑗐M
	CUIntArray aParams;
	aParams.Add((UINT)wParam);
	FlashAction(ACTION_PAUSE, &aParams);

	return 0;
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::OnUserSlow
//----------------------------------------------------------------------------------------------------
//  2. @\
//		상j[̒ᑬ{^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		WPARAM	wParam			[I] bZ[Wp[^
//		LPARAM	lParam			[I] bZ[Wp[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		LRESULT	0
//*****************************************************************************************************
LRESULT CSchematicView::OnUserSlow(WPARAM wParam, LPARAM lParam)
{
	// FlashɓwR}h𑗐M
	FlashAction(ACTION_SLOW, NULL);

	return 0;
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::OnUserNormal
//----------------------------------------------------------------------------------------------------
//  2. @\
//		상j[̒ʏ{^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		WPARAM	wParam			[I] bZ[Wp[^
//		LPARAM	lParam			[I] bZ[Wp[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		LRESULT	0
//*****************************************************************************************************
LRESULT CSchematicView::OnUserNormal(WPARAM wParam, LPARAM lParam)
{
	// FlashɓwR}h𑗐M
	FlashAction(ACTION_NORMAL, NULL);

	return 0;
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::FlashAction
//----------------------------------------------------------------------------------------------------
//  2. @\
//		FlashɓwR}hM
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		int			nActionCode			[I] ANVR[h
//		CUIntArray	*pParams			[I] tp[^̔z
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CSchematicView::FlashAction(int nActionCode, CUIntArray *pParams)
{
	CString sParams;
	CString sParam;

	// R[h
	sParams.Format("<number>%d</number>", nActionCode);

	// tp[^ҏW
	if (pParams != NULL) {
		for (int i = 0; i < pParams->GetSize(); i++) {
			sParam.Format("<number>%d</number>", pParams->ElementAt(i));
			sParams += sParam;
		}
	}

	// p[^
	sParams = "<arguments>" + sParams + "</arguments>";

	// Flash"extAction"֐Ăяo
	CallFlashFunction("extAction", sParams);
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::PostNcDestroy
//----------------------------------------------------------------------------------------------------
//  2. @\
//		EBhEj̍ŏI
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CSchematicView::PostNcDestroy()
{
	CWnd::PostNcDestroy();

	// g폜
	delete this;
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::InitFlashRect
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Ԃ̃EBhETCYݒ肷
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CSchematicView::InitFlashRect()
{
	// Y[{1ɂ
	m_fZoomRatio = 1;
	m_sizeDefault = m_sizeView;
	m_rectFlash.SetRect(0, 0, m_sizeDefault.cx, m_sizeDefault.cy);
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::GetNextScrollPos
//----------------------------------------------------------------------------------------------------
//  2. @\
//		XN[o[𑀍삵Ƃ̃XN[ʒu擾
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		int		nBar			[I] XN[o[̎ށicEj
//		UINT	nSBCode			[I] XN[vR[h
//		UINT	nPos			[I] XN[{bNẌʒu
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		int		̃XN[{bNẌʒu
//*****************************************************************************************************
int CSchematicView::GetNextScrollPos(int nBar, UINT nSBCode, UINT nPos)
{
	SCROLLINFO si;
	si.fMask = SIF_PAGE | SIF_POS | SIF_RANGE;
	GetScrollInfo(nBar, &si);
	int nNextPos = si.nPos;

	switch (nSBCode) {
	case SB_TOP:
		nNextPos = 0;
		break;
	case SB_BOTTOM:
		nNextPos = INT_MAX;
		break;
	case SB_LINEUP:
		nNextPos -= si.nMax / 100;
		break;
	case SB_LINEDOWN:
		nNextPos += si.nMax / 100;
		break;
	case SB_PAGEUP:
		nNextPos -= si.nMax / 10;
		break;
	case SB_PAGEDOWN:
		nNextPos += si.nMax / 10;
		break;
	case SB_THUMBTRACK:
		nNextPos = nPos;
		break;
	}

	if (nNextPos < si.nMin)
		nNextPos = si.nMin;
	if (nNextPos > si.nMax - (int)si.nPage)
		nNextPos = si.nMax - si.nPage;

	return nNextPos;
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::ScrollFlashWindow
//----------------------------------------------------------------------------------------------------
//  2. @\
//		FlashEBhEXN[
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CSchematicView::ScrollFlashWindow()
{
	// ēh
	if (m_bInScroll)
		return;

	m_bInScroll = TRUE;

	// XN[o[ݒ
	if (0 > m_rectFlash.left || m_sizeView.cx < m_rectFlash.right) {
		if (m_sizeView.cx > m_rectFlash.right)
			m_rectFlash.MoveToX(m_rectFlash.left + m_sizeView.cx - m_rectFlash.right);

		SCROLLINFO si;
		si.fMask = SIF_PAGE | SIF_RANGE | SIF_POS;
		si.nMin = 0;
		si.nMax = m_rectFlash.Width();
		si.nPage = m_sizeView.cx;
		si.nPos = -m_rectFlash.left;
		SetScrollInfo(SB_HORZ, &si);
		ShowScrollBar(SB_HORZ, TRUE);
	} else
		ShowScrollBar(SB_HORZ, FALSE);

	// XN[o[ݒ
	if (0 > m_rectFlash.top || m_sizeView.cy < m_rectFlash.bottom) {
		if (m_sizeView.cy > m_rectFlash.bottom)
			m_rectFlash.MoveToY(m_rectFlash.top + m_sizeView.cy - m_rectFlash.bottom);

		SCROLLINFO si;
		si.fMask = SIF_PAGE | SIF_RANGE | SIF_POS;
		si.nMin = 0;
		si.nMax = m_rectFlash.Height();
		si.nPage = m_sizeView.cy;
		si.nPos = -m_rectFlash.top;
		SetScrollInfo(SB_VERT, &si);
		ShowScrollBar(SB_VERT, TRUE);
	} else
		ShowScrollBar(SB_VERT, FALSE);

	// FlashEBhEXN[ʒuɈړ
	m_cFlash.MoveWindow(m_rectFlash, FALSE);
	m_cFlash.UpdateWindow();

	m_bInScroll = FALSE;
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::SetZoomRatio
//----------------------------------------------------------------------------------------------------
//  2. @\
//		w肵Y[{ɂFlashEBhEgEk
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		double		fZoomRatio			[I] Y[{
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CSchematicView::SetZoomRatio(double fZoomRatio)
{
	double fZoom = fZoomRatio / m_fZoomRatio;

	// Y[{ɂFlashEBhȆ傫ƈʒuvZ
	m_rectFlash.left = (int)((m_rectFlash.left - m_sizeView.cx / 2) * fZoom) + m_sizeView.cx / 2;
	m_rectFlash.top = (int)((m_rectFlash.top - m_sizeView.cy / 2) * fZoom) + m_sizeView.cy / 2;
	m_rectFlash.right = m_rectFlash.left + (int)(m_sizeDefault.cx * fZoomRatio);
	m_rectFlash.bottom = m_rectFlash.top + (int)(m_sizeDefault.cy * fZoomRatio);

	m_fZoomRatio = fZoomRatio;

	ScrollFlashWindow();
}

// Flash̃Cxg}bv
BEGIN_EVENTSINK_MAP(CSchematicView, CWnd)
	ON_EVENT(CSchematicView, 0, 150, CSchematicView::FSCommandFlash, VTS_BSTR VTS_BSTR)
END_EVENTSINK_MAP()

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::FSCommandFlash
//----------------------------------------------------------------------------------------------------
//  2. @\
//		FlashFSCommandCxg
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCTSTR		command			[I] R}h
//		LPCTSTR		args			[I] p[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CSchematicView::FSCommandFlash(LPCTSTR command, LPCTSTR args)
{
	CString sCommand = command;
	CString sArgs = args;

	if (sCommand == "ActionEnd") {
		// ANVICxg
		m_pMenuDlg->ActionEnd(atoi(sArgs));
	} else if (sCommand == "Notify") {
		// ANVʒmCxg
		if (sArgs == "CloseWindow")
			GetParent()->SendMessage(WM_CLOSE);
		else if (sArgs == "ActionStart")
			m_pMenuDlg->EnableSpeedButton(TRUE);
		else if (sArgs == "ActionEnd")
			m_pMenuDlg->EnableSpeedButton(FALSE);
	} else if (sCommand == "OpenFS") {
		// @\n}\Cxg
		CString sSchematicCode;
		sSchematicCode.Format("FS%02d", atoi(sArgs));
		CSchematic::OpenSchematicWindow(sSchematicCode);
	} else if (sCommand == "FS14") {
		// ~bgXCb`̃Tuʕ\Cxg
		CSchematic::OpenSchematicWindow("FS14_2", atoi(sArgs));
	}
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::CallFlashFunction
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Flash̊֐Ăяo
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCTSTR		pFunc			[I] ֐
//		LPCTSTR		pParams			[I] p[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CSchematicView::CallFlashFunction(LPCTSTR pFunc, LPCTSTR pParams)
{
	// ֐ĂяoXML`ŋLq
	CString sCommand;
	sCommand.Format("<invoke name=\"%s\" returntype=\"xml\">%s</invoke>", pFunc, pParams);

	try {
		// XML̓eɏ]Flash̊֐Ăяo
		m_cFlash.CallFunction(sCommand);
	} catch (CException *e) {
		// ĂяoɎsꍇ͗OX[̂łLb`
		AfxMessageBox("̋@\͖łB");
		e->Delete();
	}
}

// ȉJp@\
#ifdef _DEVELOP

#include "MenuFS08.h"

// eFt̒lϐɂ́Ať^ɃLXgȂ΂Ȃ܂
#pragma warning( disable : 4146 )	// rhWarning\ɂ邽
// eF'name' IɏOA^Cv Cu 'library' C|[g܂
#pragma warning( disable : 4192 )	// rhWarning\ɂ邽
// eFRpC̐ : sԍ̏o͂𒆎~܂B
#pragma warning( disable : 4049 )	// rhWarning\ɂ邽

// Excel
#import "C:\Program Files\Microsoft Office\Office\Mso9.dll" no_namespace rename("DocumentProperties", "DocumentPropertiesXL")
#import "C:\Program Files\Common Files\Microsoft Shared\VBA\VBA6\Vbe6ext.olb" no_namespace
#import "C:\Program Files\Microsoft Office\Office\excel9.olb" rename("DialogBox", "DialogBoxXL") rename("RGB", "RBGXL") rename("DocumentProperties", "DocumentPropertiesXL") no_dual_interfaces

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::OnRButtonUp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		E}EX{^AbvbZ[W(WM_RBUTTONUP)nh
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT	nFlags			[I] Ă鉼zL[
//		CPoint	point			[I] }EXJ[\̍W
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CSchematicView::OnRButtonUp(UINT nFlags, CPoint point)
{
	POINT posScreen;
	::GetCursorPos(&posScreen);

	CMenu menu;
	menu.LoadMenu(IDR_MENU_POPUP);
	CMenu* pPopup = menu.GetSubMenu(0);
	pPopup->CheckMenuItem(IDM_QUICK_MODE, m_bQuickMode ? MF_CHECKED : MF_UNCHECKED);
	pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, posScreen.x, posScreen.y, this);

	CWnd::OnRButtonUp(nFlags, point);
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::OnQuickMode
//----------------------------------------------------------------------------------------------------
//  2. @\
//		NCbN샂[hݒiJpj
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CSchematicView::OnQuickMode()
{
	m_bQuickMode = !m_bQuickMode;

	CallFlashFunction("setQuickMode", m_bQuickMode ? "<arguments><true/></arguments>" : "<arguments><false/></arguments>");
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::OnScreenCopy
//----------------------------------------------------------------------------------------------------
//  2. @\
//		ʃRs[GNZɓ\tiJpj
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CSchematicView::OnScreenCopy()
{
	CWnd *pParent = GetParent();
	CRect rectWindow;
	pParent->GetWindowRect(rectWindow);
	if (rectWindow.Width() != 1024 || rectWindow.Height() != 768) {
		pParent->SetWindowPos(NULL, 0, 0, 1024, 768, SWP_NOMOVE | SWP_NOZORDER);
		OnUserSizeReset(0, 0);
		pParent->Invalidate();
		pParent->UpdateWindow();
	}

	::CoInitialize(NULL);

	try {
		Excel::_ApplicationPtr	pExcel;
		Excel::WorkbooksPtr		pBooks;
		Excel::_WorkbookPtr		pBook;
		Excel::SheetsPtr		pSheets;
		Excel::_WorksheetPtr	pSheet;
		CString sSheetName;
		CString sNewName;
		_variant_t cell;

		pExcel.GetActiveObject("Excel.Application");
		pBooks = pExcel->Workbooks;
		if (pBooks != NULL) {
			pBook = pBooks->Item[1];
			if (pBook != NULL) {
				pSheets = pBook->Worksheets;
				if (pSheets != NULL) {
					pSheet = pSheets->Item[1];
					sSheetName = (LPCTSTR)pSheet->Name;
					if (sSheetName.Right(2) == "%d") {
						sNewName.Format(sSheetName, pSheets->Count);
						Excel::_WorksheetPtr pSheet2 = pSheets->Item[pSheets->Count];
						VARIANT v;
						v.vt = VT_DISPATCH;
						v.pdispVal = pSheet2;
						pSheet->Copy(vtMissing, v);
						pSheet = pSheets->Item[pSheets->Count];
						pSheet->Name = (LPCTSTR)sNewName;
						cell = pSheet->Cells->GetItem((long)3, (long)1);
						pSheet->GetRange(cell, cell)->Activate();
					} else
						pSheet = pBook->ActiveSheet;

					if (pSheet != NULL) {
						ScreenShot(GetParent());
						pSheet->Paste();

						CWnd *pMenuDlg = m_pMenuDlg;
						if (pMenuDlg != NULL) {
							if (pMenuDlg->IsKindOf(RUNTIME_CLASS(CMenuFS08))) {
								CMenuFS08 *pMenuFS08 = (CMenuFS08 *)pMenuDlg;
								if (pMenuFS08->m_pSubMenu != NULL)
									pMenuDlg = pMenuFS08->m_pSubMenu;
							}

							ScreenShot(pMenuDlg);
							cell = pSheet->Cells->GetItem(pExcel->ActiveCell->Row, (long)16);
							pSheet->GetRange(cell, cell)->Activate();
							pSheet->Paste();
						}

						cell = pSheet->Cells->GetItem((long)1, (long)1);
						pSheet->GetRange(cell, cell)->Activate();
					}
				}
			}
		}
	} catch (_com_error &e) {
		AfxMessageBox(e.Description());
	}

	::CoUninitialize();
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::ScreenShot
//----------------------------------------------------------------------------------------------------
//  2. @\
//		w肳ꂽEBhẺʃRs[GNZɓ\tiJpj
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CWnd	*pWnd			[I] ʃRs[EBhE
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CSchematicView::ScreenShot(CWnd *pWnd)
{
	CDC dcMem;
	CBitmap bmpMem;
	CRect rect;

	pWnd->SetActiveWindow();
	CDC *pDC = pWnd->GetWindowDC();
	dcMem.CreateCompatibleDC(pDC);
	pWnd->GetWindowRect(rect);
	bmpMem.CreateCompatibleBitmap(pDC, rect.Width(), rect.Height());
	ReleaseDC(pDC);
	dcMem.SelectObject(&bmpMem);
	pWnd->PrintWindow(&dcMem, 0);

	OpenClipboard();
	EmptyClipboard();
	SetClipboardData(CF_BITMAP, bmpMem.m_hObject);
	CloseClipboard();
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicView::OnStartAll
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Si𓮍ԂɂiJpj
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CSchematicView::OnStartAll()
{
	CallFlashFunction("startAll", "");
}

#endif
